diff --git a/python/py/py/_path/local.py b/python/py/py/_path/local.py
index d569404ec2..eef0cbe40b 100644
--- a/python/py/py/_path/local.py
+++ b/python/py/py/_path/local.py
@@ -1,7 +1,6 @@
 """
 local path implementation.
 """
-from __future__ import with_statement
 
 from contextlib import contextmanager
 import sys, os, re, atexit, io
@@ -12,13 +11,10 @@ from stat import S_ISLNK, S_ISDIR, S_ISREG
 
 from os.path import abspath, normpath, isabs, exists, isdir, isfile, islink, dirname
 
-if sys.version_info > (3,0):
-    def map_as_list(func, iter):
-        return list(map(func, iter))
-else:
-    map_as_list = map
+def map_as_list(func, iter):
+    return list(map(func, iter))
 
-class Stat(object):
+class Stat:
     def __getattr__(self, name):
         return getattr(self._osstatresult, "st_" + name)
 
@@ -279,7 +275,7 @@ class LocalPath(FSBase):
         res = []
         parts = self.strpath.split(self.sep)
 
-        args = filter(None, spec.split(',') )
+        args = [_f for _f in spec.split(',') if _f]
         append = res.append
         for name in args:
             if name == 'drive':
@@ -312,7 +308,7 @@ class LocalPath(FSBase):
             if args:
                 path = path.join(*args)
             return path
-        return super(LocalPath, self).dirpath(*args, **kwargs)
+        return super().dirpath(*args, **kwargs)
 
     def join(self, *args, **kwargs):
         """ return a new path by appending all 'args' as path
@@ -368,7 +364,7 @@ class LocalPath(FSBase):
                 return not kw["dir"] ^ isdir(self.strpath)
             if "file" in kw:
                 return not kw["file"] ^ isfile(self.strpath)
-        return super(LocalPath, self).check(**kw)
+        return super().check(**kw)
 
     _patternchars = set("*?[" + os.path.sep)
     def listdir(self, fil=None, sort=None):
@@ -586,7 +582,7 @@ class LocalPath(FSBase):
             if rec is True perform recursively.
         """
         if not isinstance(mode, int):
-            raise TypeError("mode %r must be an integer" % (mode,))
+            raise TypeError("mode {!r} must be an integer".format(mode))
         if rec:
             for x in self.visit(rec=rec):
                 py.error.checked_call(os.chmod, str(x), mode)
diff --git a/python/py/py/_path/svnurl.py b/python/py/py/_path/svnurl.py
index 78d71317ac..e6dc33731b 100644
--- a/python/py/py/_path/svnurl.py
+++ b/python/py/py/_path/svnurl.py
@@ -4,6 +4,7 @@ command 'svn'. This modules aims to work with svn 1.3 and higher
 but might also interact well with earlier versions.
 """
 
+from __future__ import print_function
 import os, sys, time, re
 import py
 from py import path, process
@@ -37,7 +38,7 @@ class SvnCommandPath(svncommon.SvnPathBase):
         if self.rev == -1:
             return 'svnurl(%r)' % self.strpath
         else:
-            return 'svnurl(%r, %r)' % (self.strpath, self.rev)
+            return 'svnurl({!r}, {!r})'.format(self.strpath, self.rev)
 
     def _svnwithrev(self, cmd, *args):
         """ execute an svn command, append our own url and revision """
@@ -56,7 +57,7 @@ class SvnCommandPath(svncommon.SvnPathBase):
         # fixing the locale because we can't otherwise parse
         string = " ".join(l)
         if DEBUG:
-            print("execing %s" % string)
+            print(("execing %s" % string))
         out = self._svncmdexecauth(string)
         return out
 
@@ -98,13 +99,13 @@ class SvnCommandPath(svncommon.SvnPathBase):
     def open(self, mode='r'):
         """ return an opened file with the given mode. """
         if mode not in ("r", "rU",):
-            raise ValueError("mode %r not supported" % (mode,))
+            raise ValueError("mode {!r} not supported".format(mode))
         assert self.check(file=1) # svn cat returns an empty file otherwise
         if self.rev is None:
-            return self._svnpopenauth('svn cat "%s"' % (
-                                      self._escape(self.strpath), ))
+            return self._svnpopenauth('svn cat "{}"'.format(
+                                      self._escape(self.strpath)))
         else:
-            return self._svnpopenauth('svn cat -r %s "%s"' % (
+            return self._svnpopenauth('svn cat -r {} "{}"'.format(
                                       self.rev, self._escape(self.strpath)))
 
     def dirpath(self, *args, **kwargs):
@@ -162,11 +163,11 @@ checkin message msg."""
             py.path.local instance
         """
         topath = py.path.local(topath)
-        args = ['"%s"' % (self._escape(self),),
-                '"%s"' % (self._escape(topath),)]
+        args = ['"{}"'.format(self._escape(self)),
+                '"{}"'.format(self._escape(topath))]
         if self.rev is not None:
             args = ['-r', str(self.rev)] + args
-        self._svncmdexecauth('svn export %s' % (' '.join(args),))
+        self._svncmdexecauth('svn export {}'.format(' '.join(args)))
         return topath
 
     def ensure(self, *args, **kwargs):
@@ -192,7 +193,7 @@ checkin message msg."""
         tempdir = py.path.local.mkdtemp()
         try:
             tempdir.ensure(tocreate, dir=dir)
-            cmd = 'svn import -m "%s" "%s" "%s"' % (
+            cmd = 'svn import -m "{}" "{}" "{}"'.format(
                     "ensure %s" % self._escape(tocreate),
                     self._escape(tempdir.join(basename)),
                     x.join(basename)._encodedurl())
@@ -293,14 +294,14 @@ if verbose is True, then the LogEntry instances also know which files changed.
         if rev_start == "HEAD" and rev_end == 1:
             rev_opt = ""
         else:
-            rev_opt = "-r %s:%s" % (rev_start, rev_end)
+            rev_opt = "-r {}:{}".format(rev_start, rev_end)
         verbose_opt = verbose and "-v" or ""
         xmlpipe =  self._svnpopenauth('svn log --xml %s %s "%s"' %
                                       (rev_opt, verbose_opt, self.strpath))
         from xml.dom import minidom
         tree = minidom.parse(xmlpipe)
         result = []
-        for logentry in filter(None, tree.firstChild.childNodes):
+        for logentry in [_f for _f in tree.firstChild.childNodes if _f]:
             if logentry.nodeType == logentry.ELEMENT_NODE:
                 result.append(svncommon.LogEntry(logentry))
         return result
@@ -315,7 +316,7 @@ class InfoSvnCommand:
     # locked, see 'svn help ls'
     lspattern = re.compile(
         r'^ *(?P<rev>\d+) +(?P<author>.+?) +(0? *(?P<size>\d+))? '
-            '*(?P<date>\w+ +\d{2} +[\d:]+) +(?P<file>.*)$')
+            r'*(?P<date>\w+ +\d{2} +[\d:]+) +(?P<file>.*)$')
     def __init__(self, line):
         # this is a typical line from 'svn ls http://...'
         #_    1127      jum        0 Jul 13 15:28 branch/
diff --git a/python/py/py/_path/svnwc.py b/python/py/py/_path/svnwc.py
index 00d3b4bbaf..66d9110f2d 100644
--- a/python/py/py/_path/svnwc.py
+++ b/python/py/py/_path/svnwc.py
@@ -115,7 +115,7 @@ def checkbadchars(url):
         # only check for bad chars in the non-protocol parts
         if (_check_for_bad_chars(host, ALLOWED_CHARS_HOST) \
             or _check_for_bad_chars(uripath, ALLOWED_CHARS)):
-            raise ValueError("bad char in %r" % (url, ))
+            raise ValueError("bad char in {!r}".format(url))
 
 
 #_______________________________________________________________
@@ -270,7 +270,7 @@ class SvnPathBase(common.PathBase):
     #        except (IOError, process.cmdexec.Error):
     #            break
     #    if rev is None:
-    #        raise IOError, "could not determine newest repo revision for %s" % self
+    #        raise IOError("could not determine newest repo revision for %s" % self)
     #    return rev
 
     class Checkers(common.Checkers):
@@ -327,7 +327,7 @@ def fixlocale():
     return ''
 
 # some nasty chunk of code to solve path and url conversion and quoting issues
-ILLEGAL_CHARS = '* | \ / : < > ? \t \n \x0b \x0c \r'.split(' ')
+ILLEGAL_CHARS = '* | \\ / : < > ? \t \n \x0b \x0c \r'.split(' ')
 if os.sep in ILLEGAL_CHARS:
     ILLEGAL_CHARS.remove(os.sep)
 ISWINDOWS = sys.platform == 'win32'
@@ -341,15 +341,15 @@ def _check_path(path):
             raise ValueError('path may not contain a colon (:)')
     for char in sp:
         if char not in string.printable or char in illegal:
-            raise ValueError('illegal character %r in path' % (char,))
+            raise ValueError('illegal character {!r} in path'.format(char))
 
 def path_to_fspath(path, addat=True):
     _check_path(path)
     sp = path.strpath
     if addat and path.rev != -1:
-        sp = '%s@%s' % (sp, path.rev)
+        sp = '{}@{}'.format(sp, path.rev)
     elif addat:
-        sp = '%s@HEAD' % (sp,)
+        sp = '{}@HEAD'.format(sp)
     return sp
 
 def url_from_path(path):
@@ -359,19 +359,19 @@ def url_from_path(path):
         match = _reg_allow_disk.match(fspath)
         fspath = fspath.replace('\\', '/')
         if match.group(1):
-            fspath = '/%s%s' % (match.group(1).replace('\\', '/'),
+            fspath = '/{}{}'.format(match.group(1).replace('\\', '/'),
                                 quote(fspath[len(match.group(1)):]))
         else:
             fspath = quote(fspath)
     else:
         fspath = quote(fspath)
     if path.rev != -1:
-        fspath = '%s@%s' % (fspath, path.rev)
+        fspath = '{}@{}'.format(fspath, path.rev)
     else:
-        fspath = '%s@HEAD' % (fspath,)
-    return 'file://%s' % (fspath,)
+        fspath = '{}@HEAD'.format(fspath)
+    return 'file://{}'.format(fspath)
 
-class SvnAuth(object):
+class SvnAuth:
     """ container for auth information for Subversion """
     def __init__(self, username, password, cache_auth=True, interactive=True):
         self.username = username
@@ -384,9 +384,9 @@ class SvnAuth(object):
         passwd = self.password.replace('"', '\\"')
         ret = []
         if uname:
-            ret.append('--username="%s"' % (uname,))
+            ret.append('--username="{}"'.format(uname))
         if passwd:
-            ret.append('--password="%s"' % (passwd,))
+            ret.append('--password="{}"'.format(passwd))
         if not self.cache_auth:
             ret.append('--no-auth-cache')
         if not self.interactive:
@@ -413,7 +413,7 @@ class SvnWCCommandPath(common.PathBase):
             wcpath = wcpath.localpath
         if _check_for_bad_chars(str(wcpath),
                                           ALLOWED_CHARS):
-            raise ValueError("bad char in wcpath %s" % (wcpath, ))
+            raise ValueError("bad char in wcpath {}".format(wcpath))
         self.localpath = py.path.local(wcpath)
         self.auth = auth
         return self
@@ -639,11 +639,11 @@ class SvnWCCommandPath(common.PathBase):
             updates = ''
 
         try:
-            cmd = 'status -v --xml --no-ignore %s %s %s' % (
+            cmd = 'status -v --xml --no-ignore {} {} {}'.format(
                     updates, rec, externals)
             out = self._authsvn(cmd)
         except py.process.cmdexec.Error:
-            cmd = 'status -v --no-ignore %s %s %s' % (
+            cmd = 'status -v --no-ignore {} {} {}'.format(
                     updates, rec, externals)
             out = self._authsvn(cmd)
             rootstatus = WCStatus(self).fromstring(out, self)
@@ -683,7 +683,7 @@ class SvnWCCommandPath(common.PathBase):
     def commit(self, msg='', rec=1):
         """ commit with support for non-recursive commits """
         # XXX i guess escaping should be done better here?!?
-        cmd = 'commit -m "%s" --force-log' % (msg.replace('"', '\\"'),)
+        cmd = 'commit -m "{}" --force-log'.format(msg.replace('"', '\\"'))
         if not rec:
             cmd += ' -N'
         out = self._authsvn(cmd)
@@ -788,7 +788,7 @@ recursively. """
             if py.std.sys.platform != 'win32':
                 if info.path != self.localpath:
                     raise py.error.ENOENT(self, "not a versioned resource:" +
-                            " %s != %s" % (info.path, self.localpath))
+                            " {} != {}".format(info.path, self.localpath))
             cache.info[self] = info
         return info
 
@@ -850,7 +850,7 @@ if verbose is True, then the LogEntry instances also know which files changed.
         if rev_start == "HEAD" and rev_end == 1:
                 rev_opt = ""
         else:
-            rev_opt = "-r %s:%s" % (rev_start, rev_end)
+            rev_opt = "-r {}:{}".format(rev_start, rev_end)
         verbose_opt = verbose and "-v" or ""
         locale_env = fixlocale()
         # some blather on stderr
@@ -859,7 +859,7 @@ if verbose is True, then the LogEntry instances also know which files changed.
         #                                   'svn log --xml %s %s %s "%s"' % (
         #                                    rev_opt, verbose_opt, auth_opt,
         #                                    self.strpath))
-        cmd = locale_env + 'svn log --xml %s %s %s "%s"' % (
+        cmd = locale_env + 'svn log --xml {} {} {} "{}"'.format(
             rev_opt, verbose_opt, auth_opt, self.strpath)
 
         popen = subprocess.Popen(cmd,
@@ -875,7 +875,7 @@ if verbose is True, then the LogEntry instances also know which files changed.
         except ExpatError:
             raise ValueError('no such revision')
         result = []
-        for logentry in filter(None, tree.firstChild.childNodes):
+        for logentry in [_f for _f in tree.firstChild.childNodes if _f]:
             if logentry.nodeType == logentry.ELEMENT_NODE:
                 result.append(LogEntry(logentry))
         return result
@@ -913,7 +913,7 @@ class WCStatus:
             if name not in kw or kw[name]:
                 for path in getattr(self, name):
                     d[path] = 1
-        l = d.keys()
+        l = list(d.keys())
         if sort:
             l.sort()
         return l
@@ -1151,7 +1151,7 @@ class InfoSvnWCCommand:
             self.url = d['url']
         except KeyError:
             raise  ValueError("Not a versioned resource")
-            #raise ValueError, "Not a versioned resource %r" % path
+            #raise ValueError("Not a versioned resource %r" % path)
         self.kind = d['nodekind'] == 'directory' and 'dir' or d['nodekind']
         try:
             self.rev = int(d['revision'])
@@ -1215,7 +1215,7 @@ def importxml(cache=[]):
 class LogEntry:
     def __init__(self, logentry):
         self.rev = int(logentry.getAttribute('revision'))
-        for lpart in filter(None, logentry.childNodes):
+        for lpart in [_f for _f in logentry.childNodes if _f]:
             if lpart.nodeType == lpart.ELEMENT_NODE:
                 if lpart.nodeName == 'author':
                     self.author = lpart.firstChild.nodeValue
@@ -1230,7 +1230,7 @@ class LogEntry:
                     self.date = parse_apr_time(timestr)
                 elif lpart.nodeName == 'paths':
                     self.strpaths = []
-                    for ppart in filter(None, lpart.childNodes):
+                    for ppart in [_f for _f in lpart.childNodes if _f]:
                         if ppart.nodeType == ppart.ELEMENT_NODE:
                             self.strpaths.append(PathEntry(ppart))
     def __repr__(self):
diff --git a/python/py/py/_process/cmdexec.py b/python/py/py/_process/cmdexec.py
index f83a249402..31296d94ca 100644
--- a/python/py/py/_process/cmdexec.py
+++ b/python/py/py/_process/cmdexec.py
@@ -21,8 +21,8 @@ def cmdexec(cmd):
             default_encoding = sys.getdefaultencoding() # jython may not have it
         except AttributeError:
             default_encoding = sys.stdout.encoding or 'UTF-8'
-        out = unicode(out, process.stdout.encoding or default_encoding)
-        err = unicode(err, process.stderr.encoding or default_encoding)
+        out = str(out, process.stdout.encoding or default_encoding)
+        err = str(err, process.stderr.encoding or default_encoding)
     status = process.poll()
     if status:
         raise ExecutionFailed(status, status, cmd, out, err)
diff --git a/python/py/py/_process/forkedfunc.py b/python/py/py/_process/forkedfunc.py
index 1c28530688..f334ea6004 100644
--- a/python/py/py/_process/forkedfunc.py
+++ b/python/py/py/_process/forkedfunc.py
@@ -1,4 +1,3 @@
-
 """
     ForkedFunc provides a way to run a function in a forked process
     and get at its return value, stdout and stderr output as well
@@ -111,7 +110,7 @@ class ForkedFunc:
             self._removetemp()
 
 
-class Result(object):
+class Result:
     def __init__(self, exitstatus, signal, retval, stdout, stderr):
         self.exitstatus = exitstatus
         self.signal = signal
diff --git a/python/py/py/_std.py b/python/py/py/_std.py
index 97a9853323..0a91d91cb5 100644
--- a/python/py/py/_std.py
+++ b/python/py/py/_std.py
@@ -1,6 +1,6 @@
 import sys
 
-class Std(object):
+class Std:
     """ makes top-level python modules available as an attribute,
         importing them on first access.
     """
diff --git a/python/py/py/_xmlgen.py b/python/py/py/_xmlgen.py
index 2ffcaa14b8..6e4150d92d 100644
--- a/python/py/py/_xmlgen.py
+++ b/python/py/py/_xmlgen.py
@@ -6,17 +6,12 @@ by using simple python objects.
 """
 import sys, re
 
-if sys.version_info >= (3,0):
-    def u(s):
-        return s
-    def unicode(x, errors=None):
-        if hasattr(x, '__unicode__'):
-            return x.__unicode__()
-        return str(x)
-else:
-    def u(s):
-        return unicode(s)
-    unicode = unicode
+def u(s):
+    return s
+def str(x, errors=None):
+    if hasattr(x, '__unicode__'):
+        return x.__unicode__()
+    return str(x)
 
 
 class NamespaceMetaclass(type):
@@ -36,19 +31,19 @@ class NamespaceMetaclass(type):
         return cls
 
 class Tag(list):
-    class Attr(object):
+    class Attr:
         def __init__(self, **kwargs):
             self.__dict__.update(kwargs)
 
     def __init__(self, *args, **kwargs):
-        super(Tag, self).__init__(args)
+        super().__init__(args)
         self.attr = self.Attr(**kwargs)
 
     def __unicode__(self):
-        return self.unicode(indent=0)
+        return self.str(indent=0)
     __str__ = __unicode__
 
-    def unicode(self, indent=2):
+    def str(self, indent=2):
         l = []
         SimpleUnicodeVisitor(l.append, indent).visit(self)
         return u("").join(l)
@@ -64,7 +59,7 @@ Namespace = NamespaceMetaclass('Namespace', (object, ), {
 })
 
 class HtmlTag(Tag):
-    def unicode(self, indent=2):
+    def str(self, indent=2):
         l = []
         HtmlVisitor(l.append, indent, shortempty=False).visit(self)
         return u("").join(l)
@@ -73,7 +68,7 @@ class HtmlTag(Tag):
 class html(Namespace):
     __tagclass__ = HtmlTag
     __stickyname__ = True
-    __tagspec__ = dict([(x,1) for x in (
+    __tagspec__ = {x:1 for x in (
         'a,abbr,acronym,address,applet,area,b,bdo,big,blink,'
         'blockquote,body,br,button,caption,center,cite,code,col,'
         'colgroup,comment,dd,del,dfn,dir,div,dl,dt,em,embed,'
@@ -84,22 +79,22 @@ class html(Namespace):
         'select,small,span,strike,strong,style,sub,sup,table,'
         'tbody,td,textarea,tfoot,th,thead,title,tr,tt,u,ul,xmp,'
         'base,basefont,frame,hr,isindex,param,samp,var'
-    ).split(',') if x])
+    ).split(',') if x}
 
-    class Style(object):
+    class Style:
         def __init__(self, **kw):
             for x, y in kw.items():
                 x = x.replace('_', '-')
                 setattr(self, x, y)
 
 
-class raw(object):
+class raw:
     """just a box that can contain a unicode string that will be
     included directly in the output"""
     def __init__(self, uniobj):
         self.uniobj = uniobj
 
-class SimpleUnicodeVisitor(object):
+class SimpleUnicodeVisitor:
     """ recursive visitor to write unicode. """
     def __init__(self, write, indent=0, curindent=0, shortempty=True):
         self.write = write
@@ -129,7 +124,7 @@ class SimpleUnicodeVisitor(object):
     # to avoid clashes with the tag name object
     def __object(self, obj):
         #self.write(obj)
-        self.write(escape(unicode(obj)))
+        self.write(escape(str(obj)))
 
     def raw(self, obj):
         self.write(obj.uniobj)
@@ -186,8 +181,8 @@ class SimpleUnicodeVisitor(object):
             if isinstance(value, raw):
                 insert = value.uniobj
             else:
-                insert = escape(unicode(value))
-            return ' %s="%s"' % (name, insert)
+                insert = escape(str(value))
+            return ' {}="{}"'.format(name, insert)
 
     def getstyle(self, tag):
         """ return attribute list suitable for styling. """
@@ -209,20 +204,20 @@ class SimpleUnicodeVisitor(object):
 
 class HtmlVisitor(SimpleUnicodeVisitor):
 
-    single = dict([(x, 1) for x in
+    single = {x: 1 for x in
                 ('br,img,area,param,col,hr,meta,link,base,'
-                    'input,frame').split(',')])
-    inline = dict([(x, 1) for x in
+                    'input,frame').split(',')}
+    inline = {x: 1 for x in
                 ('a abbr acronym b basefont bdo big br cite code dfn em font '
                  'i img input kbd label q s samp select small span strike '
-                 'strong sub sup textarea tt u var'.split(' '))])
+                 'strong sub sup textarea tt u var'.split(' '))}
 
     def repr_attribute(self, attrs, name):
         if name == 'class_':
             value = getattr(attrs, name)
             if value is None:
                 return
-        return super(HtmlVisitor, self).repr_attribute(attrs, name)
+        return super().repr_attribute(attrs, name)
 
     def _issingleton(self, tagname):
         return tagname in self.single
@@ -237,7 +232,7 @@ class _escape:
             u('"') : u('&quot;'), u('<') : u('&lt;'), u('>') : u('&gt;'),
             u('&') : u('&amp;'), u("'") : u('&apos;'),
             }
-        self.charef_rex = re.compile(u("|").join(self.escape.keys()))
+        self.charef_rex = re.compile(u("|").join(list(self.escape.keys())))
 
     def _replacer(self, match):
         return self.escape[match.group(0)]
@@ -245,9 +240,9 @@ class _escape:
     def __call__(self, ustring):
         """ xml-escape the given unicode string. """
         try:
-            ustring = unicode(ustring)
+            ustring = str(ustring)
         except UnicodeDecodeError:
-            ustring = unicode(ustring, 'utf-8', errors='replace')
+            ustring = str(ustring, 'utf-8', errors='replace')
         return self.charef_rex.sub(self._replacer, ustring)
 
 escape = _escape()
diff --git a/python/pyasn1-modules/pyasn1_modules/pem.py b/python/pyasn1-modules/pyasn1_modules/pem.py
index d8d815873e..80da400235 100644
--- a/python/pyasn1-modules/pyasn1_modules/pem.py
+++ b/python/pyasn1-modules/pyasn1_modules/pem.py
@@ -5,10 +5,8 @@ stSpam, stHam, stDump = 0, 1, 2
 # The markers parameters is in form ('start1', 'stop1'), ('start2', 'stop2')...
 # Return is (marker-index, substrate)
 def readPemBlocksFromFile(fileObj, *markers):
-    startMarkers = dict(map(lambda x: (x[1],x[0]),
-                            enumerate(map(lambda x: x[0], markers))))
-    stopMarkers = dict(map(lambda x: (x[1],x[0]),
-                           enumerate(map(lambda x: x[1], markers))))
+    startMarkers = dict([(x[1],x[0]) for x in enumerate([x[0] for x in markers])])
+    stopMarkers = dict([(x[1],x[0]) for x in enumerate([x[1] for x in markers])])
     idx = -1; substrate = ''
     state = stSpam
     while 1:
@@ -31,7 +29,7 @@ def readPemBlocksFromFile(fileObj, *markers):
             if sys.version_info[0] <= 2:
                 substrate = ''.join([ base64.b64decode(x) for x in certLines ])
             else:
-                substrate = ''.encode().join([ base64.b64decode(x.encode()) for x in certLines ])
+                substrate = b''.join([ base64.b64decode(x.encode()) for x in certLines ])
             break
     return idx, substrate
 
@@ -46,6 +44,6 @@ def readBase64FromFile(fileObj):
     if sys.version_info[0] <= 2:
         return ''.join([ base64.b64decode(x) for x in fileObj.readlines() ])
     else:
-        return ''.encode().join(
+        return b''.join(
             [ base64.b64decode(x.encode()) for x in fileObj.readlines() ]
         )
diff --git a/python/pyasn1-modules/setup.py b/python/pyasn1-modules/setup.py
index b7530caa8b..3ce106b000 100644
--- a/python/pyasn1-modules/setup.py
+++ b/python/pyasn1-modules/setup.py
@@ -6,6 +6,7 @@
    data structures (X.509, PKCS etc.).
 """
 
+from __future__ import print_function
 classifiers = """\
 Development Status :: 5 - Production/Stable
 Environment :: Console
diff --git a/python/pyasn1-modules/tools/cmpdump.py b/python/pyasn1-modules/tools/cmpdump.py
index 74c4f77a4e..58806ee0e5 100755
--- a/python/pyasn1-modules/tools/cmpdump.py
+++ b/python/pyasn1-modules/tools/cmpdump.py
@@ -1,6 +1,7 @@
 #!/usr/bin/python
 # Read ASN.1/PEM CMP message on stdin, parse into
 # plain text, then build substrate from it
+from __future__ import print_function
 from pyasn1.codec.der import decoder, encoder
 from pyasn1_modules import rfc4210, pem
 from pyasn1 import debug
@@ -9,8 +10,8 @@ import sys
 if len(sys.argv) == 2 and sys.argv[1] == '-d':
     debug.setLogger(debug.Debug('all'))
 elif len(sys.argv) != 1:
-    print("""Usage:
-$ cat cmp.pem | %s [-d]""" % sys.argv[0])
+    print(("""Usage:
+$ cat cmp.pem | %s [-d]""" % sys.argv[0]))
     sys.exit(-1)
     
 pkiMessage = rfc4210.PKIMessage()
@@ -21,7 +22,7 @@ if not substrate:
         
 pkiMsg, rest = decoder.decode(substrate, asn1Spec=pkiMessage)
 
-print(pkiMsg.prettyPrint())
+print((pkiMsg.prettyPrint()))
 
 assert encoder.encode(pkiMsg, defMode=False) == substrate or \
        encoder.encode(pkiMsg, defMode=True) == substrate, \
diff --git a/python/pyasn1-modules/tools/crldump.py b/python/pyasn1-modules/tools/crldump.py
index d4b0a547c6..6f61dcc119 100755
--- a/python/pyasn1-modules/tools/crldump.py
+++ b/python/pyasn1-modules/tools/crldump.py
@@ -4,13 +4,14 @@
 # original wire format.
 # CRL can be generated with "openssl openssl ca -gencrl ..." commands.
 #
+from __future__ import print_function
 from pyasn1_modules import rfc2459, pem
 from pyasn1.codec.der import encoder, decoder
 import sys
 
 if len(sys.argv) != 1:
-    print("""Usage:
-$ cat crl.pem | %s""" % sys.argv[0])
+    print(("""Usage:
+$ cat crl.pem | %s""" % sys.argv[0]))
     sys.exit(-1)
     
 asn1Spec = rfc2459.CertificateList()
@@ -27,7 +28,7 @@ while 1:
 
     if rest: substrate = substrate[:-len(rest)]
         
-    print(key.prettyPrint())
+    print((key.prettyPrint()))
 
     assert encoder.encode(key, defMode=False) == substrate or \
            encoder.encode(key, defMode=True) == substrate, \
@@ -35,4 +36,4 @@ while 1:
         
     cnt = cnt + 1
  
-print('*** %s CRL(s) re/serialized' % cnt)
+print(('*** %s CRL(s) re/serialized' % cnt))
diff --git a/python/pyasn1-modules/tools/crmfdump.py b/python/pyasn1-modules/tools/crmfdump.py
index 22bfc9d950..764b897440 100755
--- a/python/pyasn1-modules/tools/crmfdump.py
+++ b/python/pyasn1-modules/tools/crmfdump.py
@@ -1,13 +1,14 @@
 #!/usr/bin/python
 # Read ASN.1/PEM X.509 CRMF request on stdin, parse into
 # plain text, then build substrate from it
+from __future__ import print_function
 from pyasn1.codec.der import decoder, encoder
 from pyasn1_modules import rfc2511, pem
 import sys
 
 if len(sys.argv) != 1:
-    print("""Usage:
-$ cat crmf.pem | %s""" % sys.argv[0])
+    print(("""Usage:
+$ cat crmf.pem | %s""" % sys.argv[0]))
     sys.exit(-1)
     
 certReq = rfc2511.CertReqMessages()
@@ -18,7 +19,7 @@ if not substrate:
         
 cr, rest = decoder.decode(substrate, asn1Spec=certReq)
 
-print(cr.prettyPrint())
+print((cr.prettyPrint()))
 
 assert encoder.encode(cr, defMode=False) == substrate or \
        encoder.encode(cr, defMode=True) == substrate, \
diff --git a/python/pyasn1-modules/tools/ocspclient.py b/python/pyasn1-modules/tools/ocspclient.py
index b2d1dfc54f..d125cbad0a 100755
--- a/python/pyasn1-modules/tools/ocspclient.py
+++ b/python/pyasn1-modules/tools/ocspclient.py
@@ -1,11 +1,12 @@
 #!/usr/bin/python
 #
+from __future__ import print_function
 from pyasn1.codec.der import decoder, encoder
 from pyasn1_modules import rfc2560, rfc2459, pem
 from pyasn1.type import univ
 import sys, hashlib
 try:
-  import urllib2
+  import six.moves.urllib.request, six.moves.urllib.error, six.moves.urllib.parse
 except ImportError:
   import urllib.request as urllib2
 
@@ -33,7 +34,7 @@ def mkOcspRequest(issuerCert, userCert):
     userTbsCertificate = userCert.getComponentByName('tbsCertificate')
     userIssuer = userTbsCertificate.getComponentByName('issuer')
 
-    assert issuerSubject == userIssuer, '%s\n%s' % (
+    assert issuerSubject == userIssuer, '{}\n{}'.format(
         issuerSubject.prettyPrint(), userIssuer.prettyPrint()
         )
 
@@ -97,8 +98,8 @@ def parseOcspResponse(ocspResponse):
         )
 
 if len(sys.argv) != 2:
-    print("""Usage:
-$ cat CACertificate.pem userCertificate.pem | %s <ocsp-responder-url>""" % sys.argv[0])
+    print(("""Usage:
+$ cat CACertificate.pem userCertificate.pem | %s <ocsp-responder-url>""" % sys.argv[0]))
     sys.exit(-1)
 else:
     ocspUrl = sys.argv[1]
@@ -125,12 +126,12 @@ ocspReq = mkOcspRequest(issuerCert, userCert)
 # Use HTTP POST to get response (see Appendix A of RFC 2560)
 # In case you need proxies, set the http_proxy env variable
 
-httpReq = urllib2.Request(
+httpReq = six.moves.urllib.request.Request(
     ocspUrl,
     encoder.encode(ocspReq),
     { 'Content-Type': 'application/ocsp-request' }
     )
-httpRsp = urllib2.urlopen(httpReq).read()
+httpRsp = six.moves.urllib.request.urlopen(httpReq).read()
 
 # Process OCSP response
     
@@ -138,8 +139,8 @@ ocspRsp, _ = decoder.decode(httpRsp, asn1Spec=rfc2560.OCSPResponse())
 
 producedAt, certId, certStatus, thisUpdate = parseOcspResponse(ocspRsp)
 
-print('Certificate ID %s is %s at %s till %s\n' % (
+print(('Certificate ID {} is {} at {} till {}\n'.format(
        certId.getComponentByName('serialNumber'),
        certStatus,
        producedAt,
-       thisUpdate))
+       thisUpdate)))
diff --git a/python/pyasn1-modules/tools/ocspreqdump.py b/python/pyasn1-modules/tools/ocspreqdump.py
index 3a03115ea4..a7e19ae86a 100755
--- a/python/pyasn1-modules/tools/ocspreqdump.py
+++ b/python/pyasn1-modules/tools/ocspreqdump.py
@@ -3,13 +3,14 @@
 # Read ASN.1/PEM X.509 CRMF request on stdin, parse into
 # plain text, then build substrate from it
 #
+from __future__ import print_function
 from pyasn1.codec.der import decoder, encoder
 from pyasn1_modules import rfc2560, pem
 import sys
 
 if len(sys.argv) != 1:
-    print("""Usage:
-$ cat ocsp-request.pem | %s""" % sys.argv[0])
+    print(("""Usage:
+$ cat ocsp-request.pem | %s""" % sys.argv[0]))
     sys.exit(-1)
     
 ocspReq = rfc2560.OCSPRequest()
@@ -20,7 +21,7 @@ if not substrate:
         
 cr, rest = decoder.decode(substrate, asn1Spec=ocspReq)
 
-print(cr.prettyPrint())
+print((cr.prettyPrint()))
 
 assert encoder.encode(cr, defMode=False) == substrate or \
        encoder.encode(cr, defMode=True) == substrate, \
